## Continuous integration: Jenkins
    
[Continuous integration](https://en.wikipedia.org/wiki/Continuous_integration) is a best practice in software development. Typically a central automated build system checks out the latest source code from the version control repository (git, mercurial, subversion), attempts to build the software, run its unit tests and finally deploy the product to repositories and test servers. Any errors discovered are logged and reported, so that developers can get almost immediate feedback on a source code change that breaks the product overall. The automated build and deployment means that the latest _snapshot_ version of the software can be further tested and made available for user feedback.

[Jenkins CI](http://jenkins-ci.org/) is a popular server-based platform for continuous integration, often configured to be triggered by changes in the source code repository to perform a fresh Maven build and deploy the compiled snapshot artifacts to a snapshot Maven repository. Jenkins has also been used as a scientific data processing platform \cite{2e4ee812-7f0b-4dfd-b685-02e719a13d10}.

    