# Our proposal: Data Docker

We propose a solution for using Maven to manage data for Docker containers for scientific applications that need to combine reference data and larger datasets.

* [Data Maven plugin](https://github.com/stain/data-maven-plugin)
* [Docker plugins for Maven](https://github.com/stain/shootout-docker-maven)    
* [Maven project for CHEMBL dataset](https://github.com/stain/ops-chembl-rdf)
* [Maven project for derived CHEMBL linksets](https://github.com/stain/data-dependency-test)
* [Maven project for making CHEBI linksets](https://github.com/openphacts/ops-platform-setup/tree/1.5.0/scripts/chebi)
* [Script plugin](https://github.com/alexec/script-maven-plugin)
 
1. A Maven project per data set, minimally just a `pom.xml` file, but also source data in `data/`
2. Reuse existing Maven plugins for:
  1. Scripting (data transformation)
  2. Downloading external sources
  3. "unit"-testing the data
  4. Tagging and releasing artifacts
  5. Docker containers during build and runtime (e.g. to start a mysql server)
3. New: Maven Data Plugin, adds data conventions (e.g. `data/`) and adds the above plugins
4. New: Maven Research Object Plugin, adds provenance and metadata and packages the artifact as a [Research Object bundle](https://w3id.org/bundle)
5. A local Maven repository to deploy data artifacts to (they may be large!)
6. Continuous integration server (Jenkins)
    1. Builds new versions of data artifacts, triggered automatically or manually
    2. 2Independently run (No more "works on my machine")
    3. Captures build provenance
    4. deploy to repository
    5. Deploy to live instance?
7. Data consumers
    1. A `pom.xml` that depends on the data, e.g. to make derived data or to use it at runtime
    2. A Docker image that internally uses Data Docker to retrieve its reference data
    3. Artibrary users who just download the ZIP file
    4. Research Object consumers - inspect metadata -- reproducible research objects



    
    
    